'' SPYDRIVER .03
'' By Jeff Ledger
''
'' ##### ##### #   # ####  ####  ##### #   # ##### ####
'' #     #   #  # #  #   # #   #   #    # #  #     #   #  with apologies
'' ##### #####   #   #   # ####    #    # #  ###   ####   to SPYHUNTER
''     # #       #   #   # # #     #    # #  #     # #
'' ##### #       #   ####  #  #  #####   #   ##### #  #
''
'' Pushing the AiGeneric driver further than it was intended.
'' Can a driving game be created with a text driver? not sure.. :)
''
'' Requires a NES controller (settings below)
''
'' Current features: Fire works (A)
'' Crash into sides kills a player
'' Seasons change (winter has lost of good control)
'' Accleration/Deacceleration works (somewhat)


CON
  '' Uncomment section for your configuration type:

'' Demoboard/Protoboard/SpinStudio Boards
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 6_000_000
   video     = 12 '' I/O for composite video connection

{
'' Hydra Boards
   _clkmode  = xtal1 + pll8x
   _xinfreq  = 10_000_000
    video     = 24 '' I/O for composite video connection 
}   

{
'' Hybrid Boards
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 6_000_000
    video     = 24 '' I/O for composite video connection 
}
  ' NES bit encodings for NES gamepad 0
  NES0_RIGHT    = %00000000_00000001
  NES0_LEFT     = %00000000_00000010
  NES0_DOWN     = %00000000_00000100
  NES0_UP       = %00000000_00001000
  NES0_START    = %00000000_00010000
  NES0_SELECT   = %00000000_00100000
  NES0_B        = %00000000_01000000
  NES0_A        = %00000000_10000000  
  
  '' joypad serial shifter settings
  JOY_CLK = 3
  JOY_LCH = 4
  JOY_DATAOUT0 = 5
  JOY_DATAOUT1 = 6

  BLACK             = $02 
  GREY              = $03
  LWHITE            = $06
  BWHITE            = $07
  LMAGENTA          = $A3 
  WHITE             = $AF
  RED               = $A2
  LRED              = $1A
  LPURPLE           = $1B
  PURPLE            = $03 
  LGREEN            = $1C
  SKYBLUE           = $1D
  YELLOW            = $1E
  BYELLOW           = $A6
  LGREY             = $1F
  DGREY             = $08
  GREEN             = $A4
  ORANGE            = $06
  BLUE              = $A1 
  CYAN              = $1C
  MAGENTA           = $FC
  LYELLOW           = $1E

  CR                = $0D
  LF                = $0A
  TAB               = $09
  BKS               = $08

  SUMMER = $A4
  WINTER = $AF
  FALL   = $1E
     
OBJ
     text  : "aigeneric_driver"

VAR
     word  Nes_Pad     
     
PUB mainProgram   |  character_x, character_y, character_step,color, {
} board_position, { used for creating movement
} season,         { set season color for board sides
} score,          { scoreboard
} no_players,     { number of players
} acceleration,   { acceleration setting
} accel_delay,    { acceleration delay counter
} bullet_step,    { bullets shoot away from hero
} miles           { miles counter between seasons
}




  text.start(video)
  character_x := 20
  character_y := 20
  board_position := 1
  season:=summer
  score:=0
  acceleration:=0
  no_players:=3
  bullet_step:=0
  miles:=0

  DrawBackground(board_position,season,score,no_players)
  text.UpdateScreen

'  DrawCharacter (character_x, character_y, color, character_chr)
  'this method tells the object to move what is in the buffer to the display 
  '*note* -- do this as the last step in the display
'  text.UpdateScreen

  repeat
    text.cls
    DrawBackground(board_position,season,score,no_players)



    Nes_Pad := NES_Read_Gamepad

    if(Nes_Pad & NES0_RIGHT)
        character_y++
        if season == winter ''poor control during winter
          character_y++
     
    if(Nes_Pad & NES0_LEFT)
        character_y--
        if season == winter ''poor control during winter
          character_y--

    if(Nes_Pad & NES0_DOWN)
        character_x++
        acceleration--

    if(Nes_Pad & NES0_UP)
        character_x--
        acceleration++

    if(Nes_Pad & NES0_A) '' FIRE BULLETS
       color:=yellow
       if bullet_step==1
          DrawCharacter (character_x-1, character_y, color, $51)
          DrawCharacter (character_x-1, character_y+1, color, $52)
       if bullet_step==2
          DrawCharacter (character_x-3, character_y, color, $51)
          DrawCharacter (character_x-3, character_y+1, color, $52)
       if bullet_step==3
          DrawCharacter (character_x-5, character_y, color, $51)
          DrawCharacter (character_x-5, character_y+1, color, $52)

    '' Define player boundaries forward and backward.
    if character_x == 0
       character_x := 1

    if character_x < 10
       character_x := 10

    '' Check to see if hero crashed into either side of the board

    if character_y < 3    '' Did we crash into the left side?
       acceleration := 0
       no_players--
       character_x := 20
       character_y := 20

    if character_y > 20   '' Did we crash into the right side?
       acceleration := 0
       no_players--
       character_x := 20
       character_y := 20

    '' Check to see if we have run out of players
    if no_players == 0
         acceleration:=0

    '' Check to see if bullets hit another car


       
    '' *** Update all positions and refresh the screen ***

    'draw hero
    color:=white
    DrawCharacter (character_x, character_y, color, $21)
    DrawCharacter (character_x, character_y+1, color, $22)
    DrawCharacter (character_x+1,character_y,color,$41)
    DrawCharacter (character_x+1,character_y+1,color,$42)

    if acceleration > 0
      if board_position > 2
        board_position:=0
      miles++
    else
     board_position:=0

    if bullet_step > 3
       bullet_step := 0

    if miles > 0
       season:=summer
    if miles > 400
       season:=fall
    if miles > 800
       season:=winter
    if miles > 1200
       miles:=0


    bullet_step++
    board_position++
    ''miles++

    text.UpdateScreen


  
PUB  DrawBackground(pos,season_color,points,men)
   text.color(BLUE)
   text.str(string("spydriver"))
   text.color(WHITE)
   text.str(string(" score:"))
   text.dec(points)
   text.str(string(" "))
   if men == 1
     text.str(string("@",13,13))
   if men == 2
     text.str(string("@@",13,13))
   if men > 2
     text.str(string("@@@",13,13))
   if men == 0
     text.str(string(13,13,"    g a m e  o v e r"))

   text.color(season_color)

   if pos == 3
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
   if pos == 2
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
   if pos == 1
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("UVU                  UVU",13))
      text.str(string("WXX                  WXX",13))
      text.str(string("UVU                  UVU",13))

PUB DrawCharacter (character_x, character_y, crayon, character_chr)
     text.pokechar(character_x, character_y, crayon, character_chr)
  
PUB NES_Read_Gamepad : nes_bits        |  i
' //////////////////////////////////////////////////////////////////
' NES Game Paddle Read
' //////////////////////////////////////////////////////////////////       
' reads both gamepads in parallel encodes 8-bits for each in format
' right game pad #1 [15..8] : left game pad #0 [7..0]
'
' set I/O ports to proper direction
' P3 = JOY_CLK      (4)
' P4 = JOY_SH/LDn   (5) 
' P5 = JOY_DATAOUT0 (6)
' P6 = JOY_DATAOUT1 (7)
' NES Bit Encoding
'
' RIGHT  = %00000001
' LEFT   = %00000010
' DOWN   = %00000100
' UP     = %00001000
' START  = %00010000
' SELECT = %00100000
' B      = %01000000
' A      = %10000000

' step 1: set I/Os
DIRA [JOY_CLK] := 1 ' output
DIRA [JOY_LCH] := 1 ' output
DIRA [JOY_DATAOUT0] := 0 ' input
DIRA [JOY_DATAOUT1] := 0 ' input

' step 2: set clock and latch to 0
OUTA [JOY_CLK] := 0 ' JOY_CLK = 0
OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0
'Delay(1)

' step 3: set latch to 1
OUTA [JOY_LCH] := 1 ' JOY_SH/LDn = 1
'Delay(1)                            

' step 4: set latch to 0
OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0

' data is now ready to shift out, clear storage
nes_bits := 0

' step 5: read 8 bits, 1st bits are already latched and ready, simply save and clock remaining bits
repeat i from 0 to 7

 nes_bits := (nes_bits << 1)
 nes_bits := nes_bits | INA[JOY_DATAOUT0] | (INA[JOY_DATAOUT1] << 8)

 OUTA [JOY_CLK] := 1 ' JOY_CLK = 1
 'Delay(1)             
 OUTA [JOY_CLK] := 0 ' JOY_CLK = 0
 
 'Delay(1)             
' invert bits to make positive logic
nes_bits := (!nes_bits & $FFFF)

' //////////////////////////////////////////////////////////////////
' End NES Game Paddle Read
' //////////////////////////////////////////////////////////////////       

' ////////////////////////////////////////////////////////////////////




